function cbStart()
  local s = flycast.state
  print("Game started: " .. s.media)
  print("Game Id: " .. s.gameId)
  print("Display: " .. s.display.width .. "x" .. s.display.height)
end

function cbPause()
  print("Game paused")
end

function cbResume()
  print("Game resumed")
  local fuckyou = flycast.memory.read32(0x1751F14)
  flycast.emulator.displayNotification(string.format("0x%x",fuckyou), 2000)
  local maple = flycast.config.maple
  print("Maple 1: " .. maple.getDeviceType(1), 
	maple.getSubDeviceType(1, 1), maple.getSubDeviceType(1, 2))
end

function cbTerminate()
  print("Game terminated")
end

function cbLoadState()
  print("State loaded")
end

function cbVBlank()
--  print("vblank x,y=", flycast.input.getAbsCoordinates(1))
end

function cbOverlay()
  local cutsceneflag = flycast.memory.read8(0x8C751F14)
  local lifecount = flycast.memory.read8(0x8C75B744)
  local flag1 = flycast.memory.read8(0x8C75DA20)
  local flag2 = flycast.memory.read8(0x8C75DA18)
  local flag3 = flycast.memory.read32(0x8C75D9A4)
  local ui = flycast.ui

  if flag1 ~= 2 and flag2 == 2 and flag3 == 8 and cutsceneflag == 0xE then
    flycast.memory.write8(0x8C751F14, 6)
    flycast.memory.write8(0x8C75B744, 5)
  end
end

flycast_callbacks = {
  start = cbStart,
  pause = cbPause,
  resume = cbResume,
  terminate = cbTerminate,
  loadState = cbLoadState,
  vblank = cbVBlank,
  overlay = cbOverlay
}

print("Callback set")
